<?php

// Defines the base path on the server relative to the spreedwebrtc plugin 
// and traverse symbolic links if present, terminated by a slash

$path_segments = explode(DIRECTORY_SEPARATOR, dirname($_SERVER['SCRIPT_FILENAME']));
$base_path = implode(DIRECTORY_SEPARATOR, array_splice($path_segments, 0, count($path_segments) - 2));
define('WEBAPP_BASE_PATH', dirname($base_path) . "/");

// Define the server paths
set_include_path(WEBAPP_BASE_PATH. PATH_SEPARATOR .
                 WEBAPP_BASE_PATH."server/PEAR/" .  PATH_SEPARATOR .
                 "/usr/share/php/");

include(WEBAPP_BASE_PATH . "init.php");
include(WEBAPP_BASE_PATH . "config.php");

// Define the server paths
set_include_path(WEBAPP_BASE_PATH. PATH_SEPARATOR .
                 WEBAPP_BASE_PATH."server/PEAR/" .  PATH_SEPARATOR .
                 "/usr/share/php/");

include("defaults.php");

ob_start();
setlocale(LC_CTYPE, "en_US.UTF-8");

// Start the session
session_name(COOKIE_NAME);

if($_POST && array_key_exists(COOKIE_NAME, $_POST)) {
	session_id($_POST[COOKIE_NAME]);
}

session_start();

include("webapp_auth_common.php");

// check if config is correct
// we can't do this from here, because we can't pre- or redefine BASE_PATH
/*
if (defined("CONFIG_CHECK")){
	include(WEBAPP_BASE_PATH . "server/class.configcheck.php");
	new ConfigCheck(CONFIG_CHECK);
}
*/

// Include the files
// Workaround please note: using class.webappsession.php here results into a silent exit
// => therefor we can't use it
//require_once("server/core/class.webappsession.php");
require("mapi/mapi.util.php");
require("mapi/mapicode.php");
require("mapi/mapidefs.php");
require("mapi/mapitags.php");
require("mapi/mapiguid.php");
require("mapi/class.baseexception.php");
require("mapi/class.mapiexception.php");

require("server/exceptions/class.ZarafaException.php");
require("server/exceptions/class.ZarafaErrorException.php");
require("server/util.php");
include("server/gettext.php");

require("server/core/constants.php");
require("server/core/class.conversion.php");
require("server/core/class.mapisession.php");
// Workaround please note: using class.properties.php here will result in a redefine of class Properties
// => therefor we can't use it here are currently do not require it to detect if a webapp user is logged in
//require("server/core/class.properties.php");
require("server/core/class.entryid.php");

require("server/core/class.settings.php");
require("server/core/class.language.php");

require("server/core/class.state.php");
require("server/core/class.attachmentstate.php");

require("server/core/class.pluginmanager.php");
require("server/core/class.plugin.php");

// Check if we need to logout from webapp
$logout = isset($_GET['logout']);
// Check if we have been redirected from login page
$logon = isset($_GET['logon']);
// Check for loading of any other type of file
$load = sanitizeGetValue('load', false, FILENAME_REGEX);

// Create global mapi object. This object is used in many other files
$GLOBALS["mapisession"] = new MAPISession(session_id());

if (isset($_SESSION["username"]) && isset($_SESSION["password"])) {
	$sslcert_file = defined('SSLCERT_FILE') ? SSLCERT_FILE : null;
	$sslcert_pass = defined('SSLCERT_PASS') ? SSLCERT_PASS : null;

	if(!isset($_SESSION['lang']))
	    $_SESSION['lang'] = LANG;
        setlocale(LC_MESSAGES, LANG);

	$hresult = $GLOBALS["mapisession"]->logon($_SESSION["username"], $_SESSION["password"], DEFAULT_SERVER, $sslcert_file, $sslcert_pass);

	// Check if user is authenticated
	if ($GLOBALS["mapisession"]->isLoggedOn()) {
		// Authenticated

		// Instantiate Plugin Manager
		$GLOBALS['PluginManager'] = new PluginManager(ENABLE_PLUGINS);
		$GLOBALS['PluginManager']->detectPlugins(DISABLED_PLUGINS_LIST);
		$GLOBALS['PluginManager']->initPlugins(DEBUG_LOADER);
	} else {
		// Workaround instantiate Plugin Manager anyhow, otherwise it is missing in class.properties.php on line 712
		// since we are not creating webapp session we don't init the PluginManager
		$GLOBALS['PluginManager'] = new PluginManager(ENABLE_PLUGINS);
	}

} else {
	// Workaround instantiate Plugin Manager anyhow, otherwise it is missing in class.properties.php on line 712
	// since we are not creating webapp session we don't init the PluginManager
	$GLOBALS['PluginManager'] = new PluginManager(ENABLE_PLUGINS);
}

?>